import React from "react";
import { CoverView } from "@tarojs/components";
import Taro from "@tarojs/taro";

import "./index.scss";

class LocalHeader extends React.Component<any> {
  static defaultProps = {
    title: "首页",
    color: "#000000",
  };

  constructor(props: any) {
    super(props);
  }

  render() {
    const { title, color } = this.props;
    const systemInfo = Taro.getSystemInfoSync();
    // 获取胶囊的布局位置信息
    const menuButtonBoundingInfo = Taro.getMenuButtonBoundingClientRect();
    // 计算胶囊的高度
    const capsuleHeight =
      menuButtonBoundingInfo.bottom - menuButtonBoundingInfo.top;
    const height = (systemInfo.statusBarHeight || 0) + capsuleHeight + 8;
    return (
      <CoverView
        className="header"
        style={{
          height: height + "px",
          lineHeight: capsuleHeight + 8 + "px",
          paddingTop: systemInfo.statusBarHeight + "px",
          color: color
        }}
      >
        {title}
      </CoverView>
    );
  }
}

export { LocalHeader };
