import React from "react";
import {
  View,
  Image,
  Text,
  Input,
  Button,
  Textarea,
  Label,
  Radio,
  RadioGroup,
} from "@tarojs/components";
import Taro from "@tarojs/taro";

import { Picker } from "@tarojs/components";

import base from "../../config/base";
import "./index.scss";

import del from "../../images/del.png";

class aloneUpdate extends React.Component<any, any> {
  static defaultProps = {};
  #systemInfo = Taro.getSystemInfoSync();
  #area: any = [];

  constructor(props: any) {
    super(props);
    this.state = {
      uploadHeight: 0,
      selectorChecked: [0, 0, 0],
      selector: [],
      selectorText: [],
      groupList: [
        {
          name: "幼儿组(6岁以下)",
        },
        {
          name: "儿童组(7-10岁)",
        },
        {
          name: "少儿组(11-14岁)",
        },
        {
          name: "少年组(15-18岁)",
        },
      ],
      worksList: [
        {
          name: "国画组",
        },
        {
          name: "西洋画组",
        },
        {
          name: "书法组",
        },
      ],
      bmfs: 0,
      zp_local_url: "",
    };
    this.#area = Taro.getStorageSync("area");
    if (!this.#area) this.getArce();
    else {
      const l = this.#area[0].child || [];
      const province = this.#area.map((v) => v.name);
      const city = l.map((v) => v.name);
      let area = l[0].child.map((v) => v.name);
      let T: Array<String> = [];
      province[0] && T.push(province[0] || "");
      city[0] && T.push(city[0] || "");
      area[0] && T.push(area[0] || "");
      this.setState({
        selector: [province, city, area],
        selectorText: T,
      });
    }
  }

  getImageUploadSize = (e: any) => {
    this.setState({
      uploadHeight:
        ((this.#systemInfo.screenWidth - 120) / e.detail.width) *
        e.detail.height,
    });
  };

  getArce = () => {
    Taro.showLoading({
      title: "加载中",
    });
    Taro.request({
      url:
        base.baseUrlEle +
        "/topic/tool/img/%E5%B0%91%E5%84%BF%E4%B9%A6%E7%94%BB%E5%A4%A7%E8%B5%9B/area.json",
      method: "GET",
      success: (res: any) => {
        const { statusCode, data } = res;
        if (statusCode !== 200)
          return Taro.showToast({
            title: "请求失败",
            icon: "none",
          });
        this.#area = data || [];
        Taro.setStorageSync("area", data || []);
        const l = this.#area[0].child || [];
        const province = data.map((v) => v.name);
        const city = l.map((v) => v.name);
        let area = l[0].child.map((v) => v.name);
        let T: Array<String> = [];
        province[0] && T.push(province[0] || "");
        city[0] && T.push(city[0] || "");
        area[0] && T.push(area[0] || "");
        this.setState({
          selector: [province, city, area],
          selectorText: T,
        });
        Taro.hideLoading();
      },
      fail: (error: any) => {
        Taro.hideLoading();
        Taro.showToast({
          title: JSON.stringify(error),
        });
      },
    });
  };

  handleCityData = (key: Array<any>) => {
    // 处理数据。
    let provinceList = new Array(); // 省
    let cityList = new Array(); // 市
    let areaList = new Array(); // 区
    for (let i = 0; i < this.#area.length; i++) {
      // 获取省
      const v = this.#area[i] || {};
      provinceList.push(v.name);
      if (key[0] !== i) continue;
      const l = v.child || [];
      for (let o = 0; o < l.length; o++) {
        const city = l[o];
        cityList.push(city.name);
        if (key[1] !== o) continue;
        const sl = city.child || [];
        for (let j = 0; j < sl.length; j++) {
          areaList.push(sl[j].name);
        }
      }
    }
    let T: Array<String> = [];
    provinceList[key[0]] && T.push(provinceList[key[0]] || "");
    cityList[key[1]] && T.push(cityList[key[1]] || "");
    areaList[key[2]] && T.push(areaList[key[2]] || "");
    this.setState({
      selector: [provinceList, cityList, areaList], // 省市区所有的数据
      selectorChecked: key, // key是多列选择器需要展示的下标，因为是初始化，所以我们传入[0,0,0]
      selectorText: T,
    });
  };

  columnChange = (e: any) => {
    const { selectorChecked } = this.state;
    const { column, value } = e.detail;
    switch (column) {
      case 0:
        this.handleCityData([value, 0, 0]);
        break;
      case 1:
        this.handleCityData([selectorChecked[0] || 0, value, 0]);
        break;
      case 2:
        this.handleCityData([
          selectorChecked[0] || 0,
          selectorChecked[1] || 0,
          value,
        ]);
        break;
    }
  };

  create_area = () => {};

  uploadImg = () => {
    Taro.chooseImage({
      count: 1, // 可选择的图片数量
      success: (res) => {
        const tempFilePaths = res.tempFilePaths;
        this.setState({
          zp_local_url: tempFilePaths[0],
        });
      },
      complete: () => {},
    });
  };

  previewMedia = () => {
    Taro.previewMedia({
      sources: [this.state.zp_local_url],
    });
  };

  delImg = () => {
    Taro.showModal({
      title: "确定删除该图片？",
      content: "删除后需重新选择图片",
      success: (res) => {
        if (res.confirm) {
          this.setState({
            zp_local_url: "",
          });
        } else if (res.cancel) {
          console.log("用户点击取消");
        }
      },
    });
  };

  uploadele = () => {
    if (this.state.zp_local_url)
      return (
        <View className="imgP" onClick={this.delImg}>
          <Image
            mode="aspectFill"
            onClick={this.previewMedia}
            style="width: 100px;height: 100px"
            src={this.state.zp_local_url}
          ></Image>
          <Image
            className="del"
            src={del}
            style="width: 30px;height: 30px"
          ></Image>
        </View>
      );
    else
      return (
        <Image
          style={`width: ${this.#systemInfo.screenWidth - 120}px;height: ${
            this.state.uploadHeight
          }px;display: block;margin: 0 auto`}
          src="https://cxzx.smcic.net/topic/tool/img/%E5%B0%91%E5%84%BF%E4%B9%A6%E7%94%BB%E5%A4%A7%E8%B5%9B/upload.png"
          onLoad={this.getImageUploadSize}
          onClick={this.uploadImg}
        />
      );
  };

  render() {
    // const {  } = this.props;
    return (
      <View>
        <Text className="label">作者姓名*</Text>
        <Input className="input" type="text" placeholder="" focus />
        <Text className="label">联系电话*</Text>
        <Input className="input" type="number" placeholder="" />
        <Text className="label">学校班级*</Text>
        <Input className="input" type="text" placeholder="" />
        <Text className="label">指导老师*</Text>
        <Input className="input" type="text" placeholder="" />
        <Text className="label">指导老师电话*</Text>
        <Input className="input" type="number" placeholder="" />
        <Text className="label">联系地址*</Text>
        <Picker
          mode="multiSelector"
          range={this.state.selector}
          onChange={() => {}}
          onColumnChange={this.columnChange}
          value={this.state.selectorChecked}
        >
          <View className="areaList">
            {this.state.selectorText[0] && (
              <View className="areaStyle">{this.state.selectorText[0]}</View>
            )}
            {this.state.selectorText[1] && (
              <View className="areaStyle">{this.state.selectorText[1]}</View>
            )}
            {this.state.selectorText[2] && (
              <View className="areaStyle">{this.state.selectorText[2]}</View>
            )}
          </View>
        </Picker>
        <Textarea
          className="inputEle"
          placeholder="详细地址描述"
          maxlength={-1}
        />
        <Text className="label">组别*</Text>
        <RadioGroup name="zb">
          {this.state.groupList.map((item, i) => {
            return (
              <Label className="checkbox-list__label" for={i} key={i}>
                <Radio
                  color="#91725D"
                  className="checkbox-list__checkbox"
                  value={item.name}
                  checked={item.checked}
                >
                  {item.name}
                </Radio>
              </Label>
            );
          })}
        </RadioGroup>
        <Text className="label">作品类别*</Text>
        <RadioGroup name="zp">
          {this.state.worksList.map((item, i) => {
            return (
              <Label className="checkbox-list__label" for={i} key={i}>
                <Radio
                  color="#91725D"
                  className="checkbox-list__checkbox"
                  value={item.name}
                  checked={item.checked}
                >
                  {item.name}
                </Radio>
              </Label>
            );
          })}
        </RadioGroup>
        {this.uploadele()}
        <Button className="btn" size="mini">
          保存
        </Button>
      </View>
    );
  }
}

export default aloneUpdate;
