import React, { Component } from "react";
import {
  View,
  Image
} from "@tarojs/components";
import Taro from "@tarojs/taro";
import { InputBox } from "../../component/input/index";

import left from "../../images/left.png";

import "./index.scss";

export default class Examine extends Component<any, any> {
  pageCtx = Taro.getCurrentInstance().page;

  constructor(props: any) {
    super(props);
    this.state = {
      list: [
        {
          works:
            "https://cxzx.smcic.net/topic/tool/img/%E5%B0%91%E5%84%BF%E4%B9%A6%E7%94%BB%E5%A4%A7%E8%B5%9B/R-C.jfif",
          name: "张云翔",
          birthday: "2015-03-03",
          teacher: "李勇利",
          school: "清华",
          articleGroup: "书法",
          articleName: "兰亭序",
          articleDescribe:
            "展现了中国传统艺术的魅力。墨色浓淡相间，笔触流畅而有力，每一字之间形成和谐的整体。作品中融入了经典诗句，传递出深邃的哲理和人生感悟。每一个字都经过精心构思和书写，字体大小和间距恰到好处，整个作品看起来平衡而舒适。",
        },
        {
          works:
            "https://cxzx.smcic.net/topic/tool/img/%E5%B0%91%E5%84%BF%E4%B9%A6%E7%94%BB%E5%A4%A7%E8%B5%9B/R-C.jfif",
          name: "张云翔",
          birthday: "2015-03-03",
          teacher: "李勇利",
          school: "清华",
          articleGroup: "书法",
          articleName: "兰亭序",
          articleDescribe:
            "展现了中国传统艺术的魅力。墨色浓淡相间，笔触流畅而有力，每一字之间形成和谐的整体。作品中融入了经典诗句，传递出深邃的哲理和人生感悟。每一个字都经过精心构思和书写，字体大小和间距恰到好处，整个作品看起来平衡而舒适。",
        },
      ],
    };
  }

  backPage = () => {
    Taro.navigateBack();
  };

  showImage = (url:string) => {
    Taro.previewImage({
      urls: [url],
    });
  }

  render() {
    const systemInfo = Taro.getSystemInfoSync();
    // 获取胶囊的布局位置信息
    const menuButtonBoundingInfo = Taro.getMenuButtonBoundingClientRect();
    // 计算胶囊的高度
    const capsuleHeight =
      menuButtonBoundingInfo.bottom - menuButtonBoundingInfo.top;
    const height = (systemInfo.statusBarHeight || 0) + capsuleHeight + 8;
    return (
      <View className="application_list page" style={"padding-top: " + (height + 10) + 'px'}>
        <Image src={left} className="back" onClick={this.backPage} style={'top: ' + (height - 28) + 'px'}></Image>

        {this.state.list.map((v:any) => {
          return (<InputBox marginTop={0} style="margin-bottom: 5rpx">
            <View className="item">
              <Image onClick={()=>this.showImage(v.works)} className="left" src={v.works} mode="aspectFit" ></Image>
              <View className="right">
                <View>姓名：{v.name}</View>
                <View>指导老师：{v.teacher}</View>
                <View>作品名称：{v.articleName}</View>
                <View>作品简介：{v.articleDescribe}</View>
              </View>
            </View>
          </InputBox>)
        })}

      </View>
    );
  }
}
