import React, { Component } from "react";
import {
  Swiper,
  SwiperItem,
  Image,
  View,
  Text,
  Button,
} from "@tarojs/components";
import Taro from "@tarojs/taro";

import left from "../../images/left.png";

import "./index.scss";

export default class Examine extends Component<any, any> {
  pageCtx = Taro.getCurrentInstance().page;

  constructor(props: any) {
    super(props);
    this.state = {
      list: [
        {
          works:
            "https://cxzx.smcic.net/topic/tool/img/%E5%B0%91%E5%84%BF%E4%B9%A6%E7%94%BB%E5%A4%A7%E8%B5%9B/R-C.jfif",
          name: "张云翔",
          birthday: "2015-03-03",
          teacher: "李勇利",
          school: "清华",
          articleGroup: "书法",
          articleName: "兰亭序",
          articleDescribe:
            "展现了中国传统艺术的魅力。墨色浓淡相间，笔触流畅而有力，每一字之间形成和谐的整体。作品中融入了经典诗句，传递出深邃的哲理和人生感悟。每一个字都经过精心构思和书写，字体大小和间距恰到好处，整个作品看起来平衡而舒适。",
        },
        {
          works:
            "https://cxzx.smcic.net/topic/tool/img/%E5%B0%91%E5%84%BF%E4%B9%A6%E7%94%BB%E5%A4%A7%E8%B5%9B/R-C.jfif",
          name: "张云翔",
          birthday: "2015-03-03",
          teacher: "李勇利",
          school: "清华",
          articleGroup: "书法",
          articleName: "兰亭序",
          articleDescribe:
            "展现了中国传统艺术的魅力。墨色浓淡相间，笔触流畅而有力，每一字之间形成和谐的整体。作品中融入了经典诗句，传递出深邃的哲理和人生感悟。每一个字都经过精心构思和书写，字体大小和间距恰到好处，整个作品看起来平衡而舒适。",
        },
      ],
    };
  }

  change = (e: any) => {
    const {
      detail: { current },
    } = e;
    console.log(current);
  };

  backPage = () => {
    Taro.navigateBack();
  };

  render() {
    return (
      <View className="page">
        <Image src={left} className="back" onClick={this.backPage}></Image>
        <Swiper className="examine" onChange={this.change} vertical circular cacheExtent={1}>
          {this.state.list.map((v) => {
            return (
              <SwiperItem>
                <View className="zuopin">
                  <Image
                    src={v.works}
                    mode="aspectFit"
                    className="zuopin_tu"
                  ></Image>
                  <View className="zuopin_gongju" style="min-height: 280px;">
                    <View>
                      <Text>{`${v.articleName}(作者：${v.name}，生日：${v.birthday})`}</Text>
                    </View>
                    <View>
                      <Text>学校： {v.school}</Text>
                    </View>
                    <View>
                      <Text>指导老师： {v.teacher}</Text>
                    </View>
                    <View className="zuopin_jianjie">
                      <Text>{v.articleDescribe}</Text>
                    </View>
                    <View className="zuopin_gongju_tool">
                      <View className="zuopin_gongju_item">
                        <View className="zuopin_gongju_btn zuopin_gongju_btn_err">通过</View>
                      </View>
                      <View className="zuopin_gongju_item">
                        <View className="zuopin_gongju_btn">拒绝</View>
                      </View>
                    </View>
                  </View>
                </View>
              </SwiperItem>
            );
          })}
        </Swiper>
      </View>
    );
  }
}
