import React, { Component } from "react";
import { View } from "@tarojs/components";
import Taro from "@tarojs/taro";

import { LocalFooter } from "../../component/footer/index";
import { LocalHeader } from "../../component/header/index";

// 主tab页
import { Home } from "../home/index";
import { PreviousEditions } from "../previous_editions/index";
import { Application } from "../application/index";
import { Us } from "../us/index";

import back from "../../images/back.png";
import back_act from "../../images/back_act.png";
import us from "../../images/us.png";
import us_act from "../../images/us_act.png";
import baoming from "../../images/baoming.png";
import baoming_act from "../../images/baoming_act.png";
import home_act from "../../images/home_act.png";
import home from "../../images/home.png";

export default class Index extends Component<any, any> {
  pageCtx = Taro.getCurrentInstance().page;
  list = [
    {
      title: "首页",
      color: "#ffffff",
      icon_act: home_act,
      icon: home,
      unm: 0,
    },
    {
      title: "往届",
      color: "#ffffff",
      icon_act: back_act,
      icon: back,
      unm: 1,
    },
    {
      title: "报名",
      color: "#ffffff",
      icon_act: baoming_act,
      icon: baoming,
      unm: 2,
    },
    {
      title: "我的",
      color: "#ffffff",
      icon_act: us_act,
      icon: us,
      unm: 3,
    },
  ];
  
  constructor(props: any) {
    super(props);
    this.state = {
      selectPage: {
        title: "首页",
        color: "#ffffff",
        unm: 0,
      },
    };
  }

  changePage = (i: number) => {
    this.setState({
      selectPage: this.list[i],
    });
  };

  render() {
    return (
      <View className="page">
        <LocalHeader
          color={this.state.selectPage.color}
          title={this.state.selectPage.title}
        />
        <View className="main">
          {this.state.selectPage.unm === 0 && <Home />}
          {this.state.selectPage.unm === 1 && <PreviousEditions />}
          {this.state.selectPage.unm === 2 && <Application />}
          {this.state.selectPage.unm === 3 && <Us />}
        </View>
        <LocalFooter list={this.list} onClick={this.changePage} />
      </View>
    );
  }
}
